const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const product_reviews = sequelize.define(
    'product_reviews',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

rating: {
        type: DataTypes.INTEGER,
      
      

      },

review_text: {
        type: DataTypes.TEXT,
      
      

      },

moderation_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"visible",


"hidden",


"flagged"

        ],

      },

reviewed_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  product_reviews.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.product_reviews.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });

    db.product_reviews.belongsTo(db.users, {
      as: 'buyer',
      foreignKey: {
        name: 'buyerId',
      },
      constraints: false,
    });

    db.product_reviews.belongsTo(db.orders, {
      as: 'order',
      foreignKey: {
        name: 'orderId',
      },
      constraints: false,
    });

    db.product_reviews.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });



    db.product_reviews.hasMany(db.file, {
      as: 'review_images',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.product_reviews.getTableName(),
        belongsToColumn: 'review_images',
      },
    });


    db.product_reviews.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.product_reviews.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return product_reviews;
};


